﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ehmedemo
{
    class Common
    {
        public static void SetText(Control control, string text)
        {
            try
            {
                if (control.InvokeRequired)
                {
                    Action<string> actionDelegate = x => { control.Text = x; };
                    control.Invoke(actionDelegate, text);
                }
                else
                {
                    control.Text = text;
                }
            }
            catch (Exception)
            {
            }
        }

        public static string GetText(Control control)
        {
            string value = "";
            try
            {                
                if (control.InvokeRequired)
                {
                    Action actionDelegate = () => { value = control.Text; };
                    control.Invoke(actionDelegate);
                }
                else
                {
                    value = control.Text;
                }
            }
            catch (Exception)
            {
            }
            return value;
        }

        public static void SetForeColor(Control control, Color color)
        {
            try
            {
                if (control.InvokeRequired)
                {
                    Action<Color> actionDelegate = x => { control.ForeColor = x; };
                    control.Invoke(actionDelegate, color);
                }
                else
                {
                    control.ForeColor = color;
                }
            }
            catch (Exception)
            {
            }
        }

        public static void SetSelectedIndex(ComboBox control, int index)
        {
            try
            {
                if (control.InvokeRequired)
                {
                    Action<int> actionDelegate = x => { control.SelectedIndex = x; };
                    control.Invoke(actionDelegate, index);
                }
                else
                {
                    control.SelectedIndex = index;
                }
            }
            catch (Exception)
            {
            }
        }

        public static int GetSelectedIndex(ComboBox control)
        {
            int value = -1;
            try
            {
                if (control.InvokeRequired)
                {
                    Action actionDelegate = () => { value = control.SelectedIndex; };
                    control.Invoke(actionDelegate);
                }
                else
                {
                    value = control.SelectedIndex;
                }
            }
            catch (Exception)
            {
            }
            return value;
        }

        public static void SetSelectedItem(ComboBox control, string text)
        {
            try
            {
                if (control.InvokeRequired)
                {
                    Action<string> actionDelegate = x => { control.SelectedItem = x; };
                    control.Invoke(actionDelegate, text);
                }
                else
                {
                    control.SelectedItem = text;
                }
            }
            catch (Exception)
            {
            }
        }

        public static string GetSelectedItem(ComboBox control)
        {
            object value = "";
            try
            {
                if (control.InvokeRequired)
                {
                    Action actionDelegate = () => { value = control.SelectedItem; };
                    control.Invoke(actionDelegate);
                }
                else
                {
                    value = control.SelectedItem;
                }
            }
            catch (Exception)
            {
            }
            return value.ToString();
        }

        public static bool GetChecked(CheckBox control)
        {
            bool value = false;
            try
            {
                if (control.InvokeRequired)
                {
                    Action actionDelegate = () => { value = control.Checked; };
                    control.Invoke(actionDelegate);
                }
                else
                {
                    value = control.Checked;
                }
            }
            catch (Exception)
            {
            }
            return value;
        }

        public static void SetVisible(Control control, bool isVisible)
        {
            try
            {
                if (control.InvokeRequired)
                {
                    Action<bool> actionDelegate = x => { control.Visible = x; };
                    control.Invoke(actionDelegate, isVisible);
                }
                else
                {
                    control.Visible = isVisible;
                }
            }
            catch (Exception)
            {
            }
        }

        public static void SetEnable(Control control, bool isEnable)
        {
            try
            {
                if (control.InvokeRequired)
                {
                    Action<bool> actionDelegate = x => { control.Enabled = x; };
                    control.Invoke(actionDelegate, isEnable);
                }
                else
                {
                    control.Enabled = isEnable;
                }
            }
            catch (Exception)
            {
            }
        }

        public static void SetChecked(CheckBox control, bool isChecked)
        {
            try
            {
                if (control.InvokeRequired)
                {
                    Action<bool> actionDelegate = x => { control.Checked = x; };
                    control.Invoke(actionDelegate, isChecked);
                }
                else
                {
                    control.Checked = isChecked;
                }
            }
            catch (Exception)
            {
            }
        }

        public static void SetMessageBox(Form window, string text)
        {
            try
            {
                if (window.InvokeRequired)
                {
                    Action<string> actionDelegate = x => { MessageBox.Show(window, text); };
                    window.Invoke(actionDelegate, text);
                }
                else
                {
                    MessageBox.Show(window, text);
                }
            }
            catch (Exception)
            {

            }
        }

        public static string AddPoint(long value, int point)
        {
            string sign = Math.Abs(value) != value ? "-" : "";
            long data = Math.Abs(value);
            if (point > 0)
            {
                long high = data / (long)Math.Pow(10, point);
                long low = data % (long)Math.Pow(10, point);
                return sign + high + "." + string.Format("{0:D" + point + "}", low);
            }
            else
            {
                return value.ToString();
            }
        }

        public static string GetUuid()
        {
            string uuid = Properties.Settings.Default.Uuid;
            if (string.IsNullOrEmpty(uuid))
            {
                uuid = Guid.NewGuid().ToString().Replace("-", "");
                Properties.Settings.Default.Uuid = uuid;
                Properties.Settings.Default.Save();
            }
            return uuid;
        }

        public static void Sleep(int millis)
        {
            try
            {
                Thread.Sleep(millis);
            }
            catch (Exception e)
            {
                Console.WriteLine(e);
            }
        }
    }
}
