﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ehmedemo
{
    class Info : ICloneable
    {
        public static readonly ushort START_ADDR = 0x2000;
        public static readonly int READ_LENGTH = 2;

        public static readonly int CATEGORY_ME = 0;
        public static readonly int MODEL_ME_010 = 0;
        public static readonly int MODEL_ME_011 = 1;
        public static readonly int MODEL_ME_020 = 10;
        public static readonly int MODEL_ME_1XX = 100;

        public int Category { get; set; }
        public int Model { get; set; }

        public Info()
        {
            Category = 0;
            Model = 0;
        }

        public void SetValue(ushort[] value)
        {
            Category = value[0];
            Model = value[1];
        }
        
        public object Clone()
        {
            return MemberwiseClone();
        }

        public bool IsNewValueType()
        {
            return Category == CATEGORY_ME && Model == MODEL_ME_1XX;
        }

        public string GetModelName()
        {
            if(Category == CATEGORY_ME)
            {
                if(Model == MODEL_ME_010)
                {
                    return "EH-ME010";
                }
                if (Model == MODEL_ME_011)
                {
                    return "EH-ME011";
                }
                if (Model == MODEL_ME_020)
                {
                    return "EH-ME020";
                }
                if (Model == MODEL_ME_1XX)
                {
                    return "EH-ME1XX";
                }
            }
            return "";
        }
    }
}
